

--For bosses to shoot
ball_speed = 100
ball = {}
function ball.spawn(x,y,dir)
	table.insert(ball, {x = x,y = y,dir = dir,width = 5,height = 5})
end
function ball.draw()
	for i,v in ipairs(ball) do
		love.graphics.setColor(255,255,255)
		love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)
	end
end


boss = {}
boss[1] = bad
boss[2] = elf


local bad_width = 75
local bad_height = 112
local bad_pic = nil
local bad_speed = 50
local bad_start = 175


local playing = false
bad = {}
function bad.spawn()
	table.insert(bad, {shotimer = 0,shotimerlim = 1,red = 255,green = 255,blue = 255,color_timer = 0,color = false,active = false,spawn_timer = 0,spawn_timerlim = 1,spawn = 2,attacking = false,timer = 0,health = 100,timer_lim = 0.1,damage = 0.2,x = love.graphics.getWidth() * camera.scaleX / 2 - bad_width / 2, y = -bad_height - bad_start,height = bad_height,width = bad_width})
end


function bad.kill(i)
	for i,v in ipairs(bad) do
		place_effect(v.x + v.width / 2,v.y + v.height / 2,180,180,blood,100000000)
		place_effect(v.x + v.width / 2,v.y + v.height / 2,180,180,blood,100000000)
		place_effect(v.x + v.width / 2,v.y + v.height / 2,180,180,blood,100000000)
		place_effect(v.x + v.width / 2,v.y + v.height / 2,180,180,blood,100000000)
		place_effect(v.x + v.width / 2,v.y + v.height / 2,180,180,blood,100000000)
		place_effect(v.x + v.width / 2,v.y + v.height / 2,180,180,blood,100000000)
	end
	TEsound.play(death,'sound')
	TEsound.stop('song')
	TEsound.play(jingle_bells,'song')
	player.kills = player.kills + 1234567890
	bossnum = bossnum + 1
	table.remove(bad, i)
end


function bad.draw()
	for i,v in ipairs(bad) do
		love.graphics.setColor(0,255,0)
		love.graphics.rectangle('fill',love.graphics.getWidth() * camera.scaleX / 2 - v.health / 2,love.graphics.getHeight() * camera.scaleX - 8,v.health,3.5)
		love.graphics.setColor(v.red,v.green,v.blue)
		if bad_pic ~= nil then
			love.graphics.draw(bad_pic,v.x,v.y)
		else
			love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)
		end
	end
end
function bad.update(dt)
	for i,v in ipairs(bad) do
		--Death
		if v.health < 1 then
			bad.kill(i)
		end

		if v.y < 20 then
			v.y = v.y + bad_speed * dt
		else
			run_timer = true
			v.active = true
		end
		if v.active == false then
			song_pitch = song_pitch - 0.3 * dt
			TEsound.pitch('song', song_pitch)
			if song_pitch < 0 then
				TEsound.stop('song')
				playing = false
			end
		end
		if player.x + player.width > v.x and
		player.x < v.x + v.width and
		player.y + player.height > v.y and
		player.y < v.y + v.height and v.active == true then
			v.attacking = true
			player.attacked = true
			player.dir = nil
		else
			v.attacking = false
			player.attacked = false
		end
		if v.attacking == true then
			v.timer = v.timer + dt
			if v.timer > v.timer_lim then
				player.health = player.health - v.damage
				v.timer = 0
			end
		end


		--enemy.spawn(x,y,id,pic,dir)
		if v.active == true then
			if song_pitch < 1 then
				TEsound.pitch('song', song_pitch)
				song_pitch = song_pitch + 0.5 * dt
			end
			if song_pitch > 1 then
				song_pitch = 1
			end
			if playing == false then
				TEsound.playLooping(boss_song,'song')
				playing = true
			end
			v.spawn_timer = v.spawn_timer + dt
			if v.spawn_timer > v.spawn_timerlim then
				for i=1,v.spawn do
					if i == 1 then
						enemy.spawn(v.x + 16,v.y + v.height - 16,math.random(1,2),nil,'follow')
					end
					if i == 2 then
						enemy.spawn(v.x + v.width - 16 - 16,v.y + v.height - 16,math.random(1,2),nil,'follow')
					end
					v.spawn = math.random(1,2)
					v.spawn_timerlim = math.random(2.0,3.5)
					v.spawn_timer = 0
				end
			end



			--Shooting
			v.shotimer = v.shotimer + dt
			if v.shotimer > v.shotimerlim then
				--Right side of the boss
				if player.x + player.width / 2 > v.x + v.width then
					for i=1,10 - 3 do
						ball.spawn(v.x + v.width - i,v.y + math.random(5,16) * i,'right')
						ball.spawn(v.x + v.width - i,v.y + v.height / 2,'right')
						ball.spawn(v.x + v.width - i,v.y + v.height / 2,'right')
					end
					v.shotimer = 0
				end
				--Left side of the boss
				if player.x + player.width / 2 < v.x then
					for i=1,10 - 3 do
						ball.spawn(v.x + i,v.y + math.random(8.5,12.5) * i,'left')
						ball.spawn(v.x + i,v.y + v.height / 2,'left')
						ball.spawn(v.x + i,v.y + v.height / 2,'left')
					end
					v.shotimer = 0
				end
				if player.y + player.height / 2 > v.y + v.height then
					for i=1,7 - 0 do
						ball.spawn(v.x + math.random(8.5,12.5) * i,v.y + v.height - i,'down')
						ball.spawn(v.x + v.width / 2,v.y + v.height - i,'down')
						ball.spawn(v.x + v.width / 2,v.y + v.height - i,'down')
					end
					v.shotimer = 0
				end
				if player.y + player.height / 2 < v.y then
					for i=1,7 - 0 do
						ball.spawn(v.x + math.random(8.5,12.5) * i,v.y + i,'up')
						ball.spawn(v.x + v.width / 2,v.y + i,'up')
					end
					v.shotimer = 0
				end

				

			end
		end
		for ia,va in ipairs(bullet) do
			if va.x + va.width > v.x and
			va.x < v.x + v.width and
			va.y + va.height > v.y and
			va.y < v.y + v.height then
				v.health = v.health - bullet_data[va.id].damage
				v.color_timer = 0.01
				v.color = true
				table.remove(bullet, i)
			end
		end
		if v.color == true then
			v.color_timer = v.color_timer + dt
			if v.color_timer > 0.5 then
				v.color_timer = 0
				v.color = false
			end
		end
		if v.color_timer > 0 then
			v.green = 175
			v.blue = 175
		else
			v.green = 255
			v.blue = 255
		end
	end
end




function ball.update(dt)
	for i,v in ipairs(ball) do
		if #bad == 0 then
			table.remove(ball, i)
		end
		--Collision with player
		if v.x + v.width > player.x and
		v.x < player.x + player.width and
		v.y + v.height > player.y and
		v.y < player.y + player.height then
			player.health = player.health - 0.5
			table.remove(ball, i)
		end

		--Movement
		for ia,va in ipairs(bad) do
		if v.dir == 'right' then
			v.x = v.x + ball_speed * dt
			v.y = v.y + (v.y + v.height / 2 - (va.y + va.height / 2)) * dt
		end
		if v.dir == "left" then
			v.x = v.x - ball_speed * dt
			v.y = v.y + (v.y + v.height / 2 - (va.y + va.height / 2)) * dt
		end
		if v.dir == "up" then
			v.y = v.y - ball_speed * dt
			v.x = v.x + (v.x + v.width / 2 - (va.x + va.width / 2)) * dt
		end
		if v.dir == 'down' then
			v.y = v.y + ball_speed * dt
			v.x = v.x + (v.x + v.width / 2 - (va.x + va.width / 2)) * dt
		end

		--Collision with the player's snowballs.
		for ia,va in ipairs(bullet) do
			if va.x + va.width > v.x and
			va.x < v.x + v.width and
			va.y + va.height > v.y and
			va.y < v.y + v.height then
				table.remove(ball, i)
				table.remove(bullet, ia)	
			end
		end
		end
	end
end























