
--For notifying your money increasmentilizationizers
money_note = {}
	function money_note.notify(text)
		table.insert(money_note, {text = text,alpha = 255,timer = 0})
	end
	function money_note.draw()
		for i,v in ipairs(money_note) do
			love.graphics.setColor(0,255,0,v.alpha)
			love.graphics.setFont(large2)
			--love.graphics.print('$'..player.money,love.graphics.getWidth() / 2 - large2:getWidth('$'..player.money) / 2,love.graphics.getHeight() - large2:getHeight())
			love.graphics.print(v.text,love.graphics.getWidth() / 2 - large2:getWidth('$'..player.money) + large2:getWidth(v.text) / 2 ,love.graphics.getHeight() - large2:getHeight() * 2)
		end 
	end
	function money_note.update(dt)
		for i,v in ipairs(money_note) do
			v.timer = v.timer + dt
			if v.timer > 0.5 then
				v.alpha = v.alpha - 100 * dt
			end
			if v.alpha < 1 then
				table.remove(money_note, i)
			end
			if #money_note > 1 then
				for ia,va in ipairs(money_note) do
					table.remove(money_note, ia)
				end
			end
		end
	end



--Loading Powerup Images
	speedPic = love.graphics.newImage('pics/items/speed.png')
	heartPic = love.graphics.newImage('pics/items/heart.png')

--Filtering Powerup Images
	speedPic:setFilter('nearest','nearest')
	heartPic:setFilter('nearest','nearest')

--Notified when you pick up an item
pick = {}--(PickedupItem)
	function pick.spawn(text)
		table.insert(pick, {timer = 1.5,text = text,alpha = 254,red = math.random(1,255),green = math.random(1,255),blue = math.random(1,255),red_change = math.random(1500,3000),green_change = math.random(1500,3000),blue_change = math.random(1500,3000)})
	end
	function pick.draw()
		for i,v in ipairs(pick) do
			love.graphics.setColor(v.red,v.green,v.blue,v.alpha)
			love.graphics.setFont(large)
			love.graphics.print(v.text, love.graphics.getWidth() / 2 - large:getWidth(v.text) / 2,love.graphics.getHeight() / 2 - large:getHeight() / 2)
		end
	end
	function pick.update(dt)
		for i,v in ipairs(pick) do
			v.timer = v.timer - dt

			if #pick > 1 then
				for ia,va in ipairs(pick) do
					table.remove(pick, ia)
				end
			end
			v.red = v.red + v.red_change * dt
			v.green = v.green + v.green_change * dt
			v.blue = v.blue + v.blue_change * dt
			if v.timer < 0 then
				v.alpha = v.alpha - 200 * dt
			end
			if v.alpha < 1 then
				table.remove(pick, i)
			end
		end
	end



--


items = {}
function items.load()
items[1] = {width = 8,height = 8,pic = nil,timer = 0,on = false,name = "Speed",draw_timer = 0,time_limit = 5}
items[2] = {width = 8,height = 8,pic = nil,timer = 0,on = false,name = "Rapid Fire",draw_timer = 0,time_limit = 6}
items[3] = {width = 8,height = 8,pic = nil,timer = 0,on = false,name = 'Health!',draw_timer = 0,time_limit = 1}
items[4] = {width = 8,height = 8,pic = nil,timer = 0,on = false,name = 'Money',draw_timer = 0,time_limit = 1}
end
--items[3] = {}

item = {}
function item.spawn(x,y,id,pic)
	table.insert(item, {picked_up = false,x = x, y = y, id = id, pic = items[id].pic,timer = 0,width = items[id].width,height = items[id].height})
end
function item.draw()
	for i,v in ipairs(item) do
	if v.picked_up == false then
		if v.pic ~= nil then
			love.graphics.setColor(255,255,255)
			love.graphics.draw(v.pic,v.x,v.y)
		else
			love.graphics.setColor(math.random(0,255),math.random(0,255),math.random(0,255))
			love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)
		end
	end
	 end
end

--Displaying what item you picked up
	function draw_pickupItem(id)
		love.graphics.setFont(large)
		love.graphics.print(items[id].name,love.graphics.getWidth() / 2 - large:getWidth(items[id].name) / 2,love.graphics.getHeight() / 2 - large:getHeight()  / 2)
	end
--
--Sub-functionthing
	function pickup_item(id)

			if id ~= 3 and id ~= 4 and id ~= 5 then
				items[id].on = true
			end

	end
--


random_money = math.random(20,40)
function item.pickup(dt)
	for i,v in ipairs(item) do
		if player.x + player.width > v.x and
		player.x < v.x + v.width and
		player.y + player.height > v.y and
		player.y < v.y + v.height and v.picked_up == false then
			if items[v.id].on == false then
				if v.id == 3 then--Health!
					player.health = player.health + math.random(1,3)
					items[v.id].timer = 0
					items[v.id].on = false
				end
				if v.id == 4 then--Money!
					player.money = player.money + random_money
					money_note.notify('+'..random_money)
					items[v.id].timer = 0
					items[v.id].on = false
					random_money = math.random(20,40)
				end
				items[v.id].timer = 0
				TEsound.play(bell,'sound')
				pick.spawn(items[v.id].name)
				pickup_item(v.id)	
				v.picked_up = true	
			end
			if items[v.id].on == true then
				if v.id == 3 then
					player.health = player.health + math.random(1,3)
				end
				if v.id == 4 then
					player.money = player.money + random_money
					money_note.notify('+'..random_money)
					random_money = math.random(20,100)
				end
				items[v.id].timer = 0
				pick.spawn(items[v.id].name)
				pickup_item(v.id)
				v.picked_up = true
			end
		end

		if items[v.id].on == true then
			items[v.id].timer = items[v.id].timer + dt
			if items[v.id].timer < items[v.id].time_limit then
				if v.id == 1 then
					player.speed = 2750
				end
				if v.id == 2 then
					player.rate = 0.05
				end
			end
			if items[v.id].timer > items[v.id].time_limit then
				if v.id == 1 then
					player.speed = 1750
				end
				if v.id == 2 then
					player.rate = player.firerate
				end
				
				items[v.id].timer = 0
				items[v.id].on = false
				table.remove(item, i)
			end
		end

	end	
end

local snow = love.graphics.newImage('pics/snow.png')
snow:setFilter('nearest','nearest')

--Make a visual for the powerup
function powerup_draw()

end
--Misc. things that need math for the above function
function powerup_update(dt)
	if items[2].on == true then
		place_effect(player.x + player.width / 2,player.y + player.height / 2,360,180,snow,1)
	end
end




--Footsteps for speed item
local fade = 100
local foot_timer = 0
local side = 'top'
local foot_timerLim = 0.2
local foot_timerTwo = 0
foot = {}
function foot.spawn(x,y)
	table.insert(foot, {x = x,y = y,alpha = 254,width = player.width / 4, height = player.height / 4})
end
function foot.draw()
	for i,v in ipairs(foot) do
		love.graphics.setColor(255,255,255,v.alpha)
		love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)
	end
end
function foot.update(dt)
	for i,v in ipairs(foot) do
		v.alpha = v.alpha - fade * dt
		if v.alpha < 1 then
			table.remove(foot, i)
		end
	end
		if items[1].on == true then
			if player.dir ~= nil then --If the player is moving at all 
				foot_timer = foot_timer + dt

				if player.dir == "right" or player.dir == 'left' then
					if foot_timer > foot_timerLim then						
							foot.spawn(player.x,player.y + 2)
							foot_timer = 0																						
					end
					foot_timerTwo = foot_timerTwo + dt
					if foot_timerTwo > foot_timerLim / 2 then
						foot.spawn(player.x,player.y + 10)
						foot_timerTwo = 0
					end
				end
				if player.dir == "up" or player.dir == 'down' then
					if foot_timer > foot_timerLim then						
							foot.spawn(player.x + 2,player.y)
							foot_timer = 0																						
					end
					foot_timerTwo = foot_timerTwo + dt
					if foot_timerTwo > foot_timerLim / 2 then
						foot.spawn(player.x + 10,player.y)
						foot_timerTwo = 0
					end
				end
			end
		end
end











