
cane = {}
cane_speed = 225
function cane.spawn(x,y,dir)
	table.insert(cane, {x = x, y =y,dir = dir,speed = cane_speed,width = 4,height = 4,pic = nil})
end
function cane.draw()
	for i,v in ipairs(cane) do
		if v.pic ~= nil then
			love.graphics.setColor(255,255,255)
			love.graphics.draw(v.pic,v.x,v.y)
		end
		if v.pic == nil then
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)
		end
	end
end
function cane.update(dt)
	for i,v in ipairs(cane) do
		if v.dir == 'right' then
			v.x = v.x + v.speed * dt
		end
		if v.dir == 'left' then
			v.x = v.x - v.speed * dt
		end
		if v.dir == 'up' then
			v.y = v.y - v.speed * dt
		end
		if v.dir == 'down' then
			v.y = v.y + v.speed * dt
		end
		if v.x > love.graphics.getWidth() * camera.scaleX or v.x - v.width < 0 or v.y - v.height < 0 or v.y > love.graphics.getHeight() * camera.scaleY then
			table.remove(cane, i)
		end
		if v.x + v.width > player.x and
		v.x < player.x + player.width and
		v.y + v.height > player.y and
		v.y < player.y + player.height then
			player.health = player.health - 1
			table.remove(cane, i)
		end
	end
end


kid = {}
kid_speed = 100
function kid.spawn(x,y,dir)
	table.insert(kid, {spawn_item = math.random(0,100),attacking = false,attack_timer = 0,x = x,timer = 0,timerlim = 2,y = y,speed = kid_speed,stopping_point = nil,stop_chosen = false,dir = dir,width = 16,height = 16,health = 5,stopped = false,pic = nil})
end
function kid.draw()
	for i,v in ipairs(kid) do
		if v.pic ~= nil then
			love.graphics.setColor(255,255,255)
			love.graphics.draw(v.pic,v.x,v.y)
		end
		if v.pic == nil then
			love.graphics.setColor(255,0,255)
			love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)
		end
	end	
end
kid_stopX = math.random(1,love.graphics.getWidth() * camera.scaleX - 16)
kid_stopY = math.random(1,love.graphics.getHeight() * camera.scaleY - 16)
function kid.update(dt)
	for i,v in ipairs(kid) do
		if v.stopped == true then
			if v.x + v.width < 0 or v.x > love.graphics.getWidth() * camera.scaleX or v.y + v.height < 0 or v.y > love.graphics.getHeight() * camera.scaleY then
				v.health = 0
			end
		end
		if v.stop_chosen == false then
			if v.dir == 'right' or v.dir == 'left' then
				v.stopping_point = kid_stopX
				kid_stopX = math.random(1,love.graphics.getWidth() * camera.scaleX - v.width)
				v.stop_chosen = true
			end
			if v.dir == 'up' or v.dir == 'down' then
				v.stopping_point = kid_stopY
				kid_stopY = math.random(1,love.graphics.getHeight() * camera.scaleY - v.height)
				v.stop_chosen = true
			end
		end
			if v.dir == 'right' and v.stopped == false then
				v.x = v.x + v.speed * dt
			end
			if v.dir == 'left' and v.stopped == false then
				v.x = v.x - v.speed * dt
			end
			if v.dir == 'up' and v.stopped == false then
				v.y = v.y - v.speed * dt
			end
			if v.dir == 'down' and v.stopped == false then
				v.y = v.y + v.speed * dt
			end

			--Stopping
			if v.stop_chosen == true then
				if v.dir == 'right' then
					if v.x > v.stopping_point then
						v.stopped = true
					end
				end
				if v.dir == 'left' then
					if v.x < v.stopping_point then
						v.stopped = true
					end
				end
				if v.dir == 'down' then
					if v.y > v.stopping_point then
						v.stopped = true
					end
				end
				if v.dir == 'up' then
					if v.y < v.stopping_point then
						v.stopped = true
					end
				end
			end
		

		--Throwing Candy Canes
		if v.stopped == true then
			v.timer = v.timer + dt
			if v.timer > v.timerlim then

				--Bottom of the kid
				if player.x + player.width > v.x - 100 and
				player.x + player.width / 2 < v.x + v.width + 100 and
				player.y + player.height / 2 > v.y + v.height then
					cane.spawn(v.x + v.width / 2 - 2,v.y + v.height,'down')
				end

				--Top of the kid
				if player.x + player.width / 2 > v.x - 100 and
				player.x + player.width / 2 < v.x + v.width + 100 and
				player.y + player.height / 2 < v.y then
					cane.spawn(v.x + v.width / 2 - 2,v.y - 4,'up')
				end

				--Left of the kid
				if player.y + player.height / 2 > v.y - 100 and
				player.y + player.height / 2 < v.y + v.height + 100 and
				player.x + player.width / 2 < v.x then
					cane.spawn(v.x - 4,v.y + v.height / 2 - 2,'left')
				end

				--Right of the kid
				if player.y + player.height / 2 > v.y - 100 and
				player.y + player.height / 2 < v.y + v.height + 100 and
				player.x + player.width / 2 > v.x + v.width then
					cane.spawn(v.x + v.width,v.y + v.height / 2 - 2,'right')
				end
				TEsound.play(snowball,'sound')
				v.timer = 0
			end
		end


		--Die Whore
		if v.health < 1 then
			TEsound.play(death,'sound')
			point.spawn(1)
			place_effect(v.x + v.width / 2,v.y + v.height / 2,math.random(90,360),math.random(350,360),blood,100000000)
			player.kills = player.kills + 1
			if v.spawn_item < 25 then
				item.spawn(v.x + v.width / 2,v.y + v.height / 2,math.random(1,#items),nil)
			end
			table.remove(kid, i)
		end
		--

		--Attacking the fat one.
		if v.x + v.width > player.x and
		v.x < player.x + player.width and
		v.y + v.height > player.y and
		v.y < player.y + player.height then
			v.attacking = true
			player.dir = nil
		else
			v.attacking = false
			player.attacked = false
		end

		if v.attacking == true then
			v.attack_timer = v.attack_timer + dt
			if v.attack_timer > 0.7 then
				player.color = true
				player.color_timer = 0
				player.health = player.health - 1
				v.attack_timer = 0
			end
			player.attacked = true
		end
		if v.stopped == false then
			player.attacked = false
		end

		for ia,va in ipairs(bullet) do
			if va.x + va.width > v.x and
			va.x < v.x + v.width and
			va.y + va.height > v.y and
			va.y < v.y + v.height then
				--left
				if player.x + player.width > v.x and
				player.x < v.x + v.width and
				player.y + player.height > v.y and
				player.y < v.y + v.height then
				else
				if va.y + va.height / 2 > v.y and
				va.y + va.height / 2 < v.y + v.height and
				va.x + va.width / 2 < v.x + v.width / 2 then
					v.x = v.x + 2.5
				end
				--right
				if va.y + va.height / 2 > v.y and
				va.y + va.height / 2 < v.y + v.height and
				va.x + va.width / 2 > v.x + v.width / 2 then
					v.x = v.x - 2.5
				end
				--Top
				if va.x + va.width / 2 > v.x and
				va.x + va.width / 2 < v.x + v.width and
				va.y + va.height / 2 < v.y + v.height then
					v.y = v.y + 2.5
				end
				--Bottom
				if va.x + va.width / 2 > v.x and
				va.x + va.width / 2 < v.x + v.width and
				va.y + va.height / 2 > v.y + v.height then
					v.y = v.y - 2.5
				end
				end
				v.health = v.health - bullet_data[va.id].damage
				table.remove(bullet, ia)
			end
		end
	end
end







