require "camera"
require "particles"
require "sound"
require "menu"

require "shoot"
require "player"

require "spells"

require "items"
require "enemies"
require 'deer'
require "boss"
require "kids"
require "wave"


require "env"
require "interface"
function love.load()

	coal = love.graphics.newImage('pics/coal.png')
	coal:setFilter('nearest','nearest')
	player.load()

	master_timer = 120

	blood = love.graphics.newImage('pics/blood.png')
	blood:setFilter('nearest','nearest')
	fire = love.graphics.newImage('pics/fire.png')
	fire:setFilter('nearest','nearest')
	--Fonts
	small = love.graphics.newFont('fonts/font2.ttf',27)
	medium = love.graphics.newFont('fonts/font2.ttf',38)
	large = love.graphics.newFont('fonts/font.ttf',54)
	large2 = love.graphics.newFont('fonts/font2.ttf',54)

	mfont = love.graphics.newFont('fonts/menu.ttf',54)
	--
	gamestate = "menu"

	love.graphics.setBackgroundColor(125,20,15)

	screenWidth = love.graphics.getWidth() * camera.scaleX
	screenHeight = love.graphics.getHeight() * camera.scaleY

	TEsound.volume('step', 0)


	sound_volume = 0.7
	song_volume = 0.7


	run_timer = true

	id_displayed = nil

	--item.spawn(50,50,5,nil)



	song_pitch = 1

	TEsound.pitch('song', song_pitch)

	menu.load()
	plus_load()

end
deathalpha = 1
deathtimer = 0
deathalpha2 = 255

imdead = false
--Death
function die(dt)
	if player.health < 1 then
		if imdead == false then
			TEsound.play(death,'sound')
			place_effect(player.x + player.width / 2,player.y + player.height / 2,math.random(90,360),math.random(350,360),blood,100000000)
			imdead = true
		end
		TEsound.pitch('song', song_pitch)
		song_pitch = song_pitch - 0.3 * dt
		if song_pitch < 0 then
			TEsound.stop('song')
		end
		gamestate = 'dead'
		deathtimer = deathtimer + dt
		if deathalpha2 > 1 then
			deathalpha2 = deathalpha2 - 100 * dt
		end
		if deathalpha2 < 1 then
			deathalpha2 = 1
		end
		if deathtimer > 3 then
				deathalpha = deathalpha + 200 * dt
		end
		if deathalpha > 254 then
				plus_load()
				player.load()
				TEsound.stop('song')
				for i=0,#button do
					table.remove(button, i)
				end
				for i=0,#button do
					table.remove(button, i)
				end
				for i=0,#scale do
					table.remove(scale, i)
				end
				for i=0,#scale do
					table.remove(scale, i)
				end
				for i=0,#scale do
					table.remove(scale, i)
				end
				player.load()
				wavenum = 1
				master_timer = 121
				gamestate = 'menu'
				end
				if #button == 0 and #scale == 0 then
					menu.load()
				end
	end
end
function love.update(dt)
	--Deleting buttons:D

	--delete_allButtons()
	--Shouldn't have made the menu system so sloppy

	if gamestate ~= 'upgrade' then
		for i = 0,#plus do
			table.remove(plus, i)
		end
	end
	--Scaling camera
	if gamestate == "playing" then
		camera.scaleX = 0.3
		camera.scaleY = 0.3
	end
	if gamestate == "menu" then
		for i=0,#bad do
			table.remove(bad, i)
		end
		for i=0,#item do
			table.remove(item, i)
		end
		for i=0,#bullet do
			table.remove(bullet, i)
		end
		for i=0,#bomb do
			table.remove(bomb, i)
		end
		song_pitch = 1
		camera.scaleX = 1
		camera.scaleY = 1

		--Kill all enemies
		for i=0,#enemy do
			table.remove(enemy, i)
		end
		for i=0,#kid do
			table.remove(kid, i)
		end
		for i=0,#rain do
			table.remove(rain, i)
		end

		--Particles
		for i=0,#effects do
			table.remove(effects, i)
		end
	end


	TEsound.cleanup()
	if gamestate == 'playing' or gamestate == 'dead' then
		die(dt)
		update_effect(dt)
	end
	if gamestate == 'dead' then
		for i=0,#note do
			table.remove(note, i)
		end
	end	
	--If the game is playing (not in the menu)
	if gamestate == "playing" then
		notify_upgrade()
		deathalpha = 1
		deathtimer = 0
		deathalpha2 = 0
		--Remove all buttons fool!
		for i=0,#button do
			table.remove(button, i)
		end
		--camera:move(dt)
		player.update(dt)
		player.shoot(dt)
		wave.update(dt)
		enemy.update(dt)
		rain.update(dt)
		bullet.update(dt)
		bomb.update(dt)

		note.update(dt)
		item.pickup(dt)
		update_effect(dt)
		foot.update(dt)
		powerup_update(dt)
		point.update(dt)
		pain.update(dt)
		bad.update(dt)
		ball.update(dt)
		player.colorchange(dt)
		kid.update(dt)

		interface.update(dt)
		money_note.update(dt)
		pick.update(dt)
		cane.update(dt)
	end

	TEsound.volume('song',song_volume)
	TEsound.volume('sound',sound_volume)
	scale.set()
	if gamestate == "menu" or gamestate == 'options' or gamestate == 'paused' or gamestate == 'upgrade' then
		plus.update(dt)
		button.update(dt)
	end
	notify_update(dt)
end
function love.keypressed(key)
	if gamestate == "playing" then
		player.move(key)
		--Pause Menu
		if key == 'p' or key == 'escape' then
			TEsound.pause('sound')
			player.dir = nil -- Stop him from moving
			pause.load()
			switch_timer = 0
			switch = false
			direct_upgrade = false
			gamestate = "paused"
		end
		
		if key == 'u' then
				direct_upgrade = true
					for i=0,#button do
						table.remove(button, i)
					end
					for i=0,#button do
						table.remove(button, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					delete_buttons = true
					for i=0,#scale do
						table.remove(scale, i)
					end
					gamestate = 'upgrade'
		end
		if #button == 0 and #scale == 0 and gamestate == 'upgrade' then
					upgrade.load()
			end
	end
	button.press_key(key)
end
function love.keyreleased(key)
	if gamestate == "playing" then
		player.animreset(key)
	end
end	
function love.mousepressed(x,y,key)
	if gamestate == "menu" or gamestate == 'options' or gamestate == 'paused' or gamestate == 'upgrade' then
		button.click(x,y,key)
		scale.update(x,y)
		plus.upgrade(x,y)
	end
end
fade_alpha = 155
function love.draw()
	camera:set()

	--Again, if the game is playing.
	if gamestate == "playing" or gamestate == 'dead' or gamestate == 'paused' or gamestate == 'upgrade' then

		bg.draw()
		draw_effect()
		foot.draw()
		item.draw()
		bomb.draw()
		powerup_draw()
		bad.draw()
		player.draw()
		bullet.draw()
		ball.draw()
		cane.draw()
		kid.draw()
		enemy.draw()
		rain.draw()
		pain.draw()
		if gamestate == 'paused' or gamestate == 'upgrade' then
			love.graphics.setColor(0,0,0,fade_alpha)
			love.graphics.rectangle('fill',0,0,love.graphics.getWidth(),love.graphics.getHeight())
		end
	end
	camera:unset()
	if gamestate == 'playing' or gamestate == 'dead' then
		point.draw()
		interface.draw()
		pick.draw()
		if id_displayed ~= nil then
			draw_pickupItem(id_displayed)
		end
		note.draw()
		money_note.draw()
		if gamestate == 'dead' then
			if gamestate == 'dead' then
			love.graphics.setFont(large2)
			love.graphics.setColor(math.random(0,255),math.random(0,255),math.random(0,255))
			love.graphics.print('Game Over!',love.graphics.getWidth() / 2 - large2:getWidth('Game Over!') / 2,love.graphics.getHeight() / 2 - large:getHeight() / 2)
			love.graphics.setColor(0,0,0,deathalpha)
			love.graphics.rectangle('fill',0,0,love.graphics.getWidth(),love.graphics.getHeight())
			end
		end
	end
	if gamestate == "menu" or gamestate == 'options' or gamestate == 'paused' or gamestate == 'upgrade' then
		button.draw()
		menu.draw()
		pause.draw()
		scale.draw()
		options_draw()
		plus.draw()
		if gamestate == 'upgrade' then
			notify_draw()
		end
	end

end