
switch_timer = 0
switch = false

menu_note = {}

direct_upgrade = false --If you went directly to the upgrade menu

delete_buttons = false
function delete_allButtons()
	if delete_buttons == true then
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#scale do
		table.remove(scale, i)
	end
	delete_buttons = false
	end
end	

--Notifications in the menu
notify_menu = {}
function notify(text,y,color)
	table.insert(notify_menu, {text = text,alpha = 255,y = y,timer = 0,color = color})
end
function notify_draw()
	for i,v in ipairs(notify_menu) do
		if v.color == 'red' then
			love.graphics.setColor(255,0,0,v.alpha)
		end
		if v.color == 'green' then
			love.graphics.setColor(0,255,0,v.alpha)
		end
		love.graphics.setFont(large2)
		love.graphics.print(v.text,love.graphics.getWidth() / 2 - large2:getWidth(v.text) / 2,v.y)
	end
end
function notify_update(dt)
	for i,v in ipairs(notify_menu) do
		v.timer = v.timer + dt
		if #notify_menu > 1 then
			for ia,va in ipairs(notify_menu) do
				table.remove(notify_menu, ia)
			end
		end
		if v.timer > 0.8 then
			v.alpha = v.alpha - 350 * dt
		end
		if v.alpha < 1 then
			table.remove(notify_menu, i)
		end
	end
end
-----------------------------------


--Scales for volume control
scale = {}
function scale.spawn(x,y,var)
	if var == 'song volume' then
		table.insert(scale, {x = x,y = y,var = var,width = song_volume * 200,height = 10,clicked = false})
	end
	if var == 'sound volume' then
		table.insert(scale, {x = x,y = y,var = var,width = sound_volume * 200,height = 10,clicked = false})
	end
end
function scale.draw()
	for i,v in ipairs(scale) do
		love.graphics.setColor(100,100,100)
		love.graphics.rectangle('fill',v.x,v.y,200,v.height)

		love.graphics.setColor(0,255,0)
		love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)

		love.graphics.setColor(255,255,255)
		love.graphics.rectangle('fill',v.x + v.width,v.y - 5,10,20)
		love.graphics.setFont(medium)
		love.graphics.print(v.var,v.x,v.y - 50)

	end
end
function scale.update(x,y)
	mousex = love.mouse.getX()
	mousey = love.mouse.getY()
	for i,v in ipairs(scale) do
		if x > v.x - 35 and
		x < v.x + 200 + 35 and
		y > v.y - 35 and
		y < v.y + v.height + 35 then	
			if mousex > v.x and
			mousex < v.x + 200 then
				v.width = mousex - v.x
			end
			if mousex < v.x then
				v.width = 0
			end
			if mousex > v.x + 200 then
				v.width = 200
			end
		end
	end
end
function scale.set()
	for i,v in ipairs(scale) do
		if v.var == "song volume" then
			song_volume = v.width / 200
		end
		if v.var == 'sound volume' then
			sound_volume = v.width / 200
		end
	end	
end



button = {}
function button.press_key(key)
	if gamestate == 'paused' then
		if key == 'escape' and
		switch == true then
				TEsound.resume('song')
				TEsound.resume('sound')
				gamestate = 'playing'
				switch_timer = 0
		end
	end
	if gamestate == 'upgrade' then
		if key == 'escape' and
		switch == true then
			if direct_upgrade == false then
				delete_buttons = true
					for i=0,#button do
						table.remove(button, i)
					end
					for i=0,#button do
						table.remove(button, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#plus do
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
					end
					gamestate = 'paused'
				
					switch_timer = 0
				end
				if direct_upgrade == true then
					TEsound.resume('song')
					TEsound.resume('sound')
					gamestate = 'playing'
				end
		end
	end
end
function button.spawn(x,y,text,id,price)
	table.insert(button, {x = x,y = y,text = text,price = price,id = id,red = 0,green = 255,blue = 0,bgred = 0,bggreen = 0,bgblue = 0,width = mfont:getWidth(text),height = mfont:getHeight(text)})
end
function button.draw()
	for i,v in ipairs(button) do
		love.graphics.setColor(v.bgred,v.bggreen,v.bgblue)
		love.graphics.setFont(mfont)
		love.graphics.rectangle('fill',v.x - 10,v.y - 10,v.width + 10,v.height + 10)
		love.graphics.setColor(255,0,0)
		for i=0,2 do
			love.graphics.setColor(255 - i * (i * 10),0,0)
			love.graphics.rectangle('line',v.x - (10 - i),v.y - (10 - i),v.width + 10 - i - 1,v.height + 10 - i - 1)
		end
		love.graphics.rectangle('line',v.x - 10,v.y - 10,v.width + 10,v.height + 10)
		love.graphics.rectangle('line',v.x - 9,v.y - 9,v.width + 9,v.height + 9)
		love.graphics.setColor(v.red,v.green,v.blue)
		love.graphics.print(v.text,v.x,v.y)
	end
end
function button.update(dt)
	--For exiting the menu with the escape button
	if switch == false then
		switch_timer = switch_timer + dt
	end
	if switch_timer > 0.1 then
		switch = true
	end
	if switch_timer < 0.1 then
		switch = false
	end
	if #button == 0 and #scale == 0 and gamestate == 'paused' and #plus == 0 then
					pause.load()
				end
	for i,v in ipairs(button) do
		mousex = love.mouse.getX()
		mousey = love.mouse.getY()

		if mousex > v.x - 10 and
		mousex < v.x + v.width + 10 and
		mousey > v.y - 10 and
		mousey < v.y + v.height + 10 then
			v.bgred = 130
			v.bggreen = 130
			v.bgblue = 130
			v.green = 235
		else
			v.bgred = 140
			v.bggreen = 140
			v.bgblue = 140
			v.green = 255
		end
	end
end	
options = false
function options_buttonLoad()
	button.spawn(5,love.graphics.getHeight() - large:getHeight() - 10,'Back','back')
	gamestate = 'options'
end
function options_draw()
	if gamestate == 'options' then
	love.graphics.setFont(large2)
	love.graphics.setColor(0,0,0)
	love.graphics.print("Window Size",love.graphics.getWidth() / 2 - large2:getWidth("Window Size") / 2,large2:getHeight() * 3)
	end
end
function options_load()
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#button do
		table.remove(button, i)
	end
	for i=0,#scale do
		table.remove(scale, i)
	end
	for i=0,#scale do
		table.remove(scale, i)
	end
	for i=0,#scale do
		table.remove(scale, i)
	end
	for i=0,#scale do
		table.remove(scale, i)
	end
	for i=0,#scale do
		table.remove(scale, i)
	end
	for i=0,#scale do
		table.remove(scale, i)
	end
	if #button == 0 then
		button.spawn(5,love.graphics.getHeight() - large:getHeight() - 10,'Back','back')
		button.spawn(love.graphics.getWidth() / 2 - mfont:getWidth('Small') / 2,250,'Small','small')
		button.spawn(love.graphics.getWidth() / 2 - mfont:getWidth('Medium') / 2,250 + large:getHeight() * 2 + 10,'Medium','medium')
		button.spawn(love.graphics.getWidth() / 2 - mfont:getWidth('Huge') / 2,250 + large:getHeight() * 4 + 20,'Huge','large')
		scale.spawn(15,love.graphics.getHeight() / 2 - large:getHeight(),"song volume")
		scale.spawn(15,love.graphics.getHeight() / 2 + large:getHeight(),"sound volume")	
		gamestate = 'options'
	end
end




function button.click(x,y,key)
	for i,v in ipairs(button) do
		if x > v.x - 10 and
		x < v.x + v.width + 10 and
		y > v.y - 10 and
		y < v.y + v.height + 10 then
			if v.id == "start" then
				spell.load()
				items.load()
				note.spawn('Wave 1')
				TEsound.playLooping(jingle_bells,'song')
				gamestate = 'playing'
			end	
			if v.id == "quit" then
				love.event.quit()
			end	
			if v.id == 'options' then
				options_load()
			end

			--Window size
			if gamestate == 'options' then
				if v.id == 'small' then
					love.graphics.setMode(900,600)
					options_load()				
				end
				if v.id == 'medium' then
					love.graphics.setMode(1200,750)
					options_load()				
				end
				if v.id == 'large' then
					love.graphics.setMode(1350,1000)
					options_load()				
				end
			end


			--Pause menu
			if gamestate == 'paused' then
				if v.id == 'play' then
					TEsound.resume('song')
					TEsound.resume('sound')
					gamestate = 'playing'
				end
				if v.id == 'menu' then
					plus_load()
					player.load()
					TEsound.stop('song')
					for i=0,#button do
						table.remove(button, i)
					end
					delete_buttons = true
					for i=0,#button do
						table.remove(button, i)
						table.remove(button, i)
						table.remove(button, i)
						table.remove(button, i)
						table.remove(button, i)
						table.remove(button, i)
						table.remove(button, i)
						table.remove(button, i)
						table.remove(button, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
						table.remove(scale, i)
						table.remove(scale, i)
						table.remove(scale, i)
						table.remove(scale, i)
						table.remove(scale, i)
						table.remove(scale, i)
						table.remove(scale, i)
						table.remove(scale, i)
						table.remove(scale, i)
						table.remove(scale, i)
					end

					player.load()
					wavenum = 1
					master_timer = 121
					gamestate = 'menu'
				end
				if v.id == 'upgrade' then
					for i=0,#button do
						table.remove(button, i)
					end
					for i=0,#button do
						table.remove(button, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					delete_buttons = true
					for i=0,#scale do
						table.remove(scale, i)
					end
					gamestate = 'upgrade'
				end
				if #button == 0 and #scale == 0 and gamestate == 'menu' then
					menu.load()
				end
				if #button == 0 and #scale == 0 and gamestate == 'upgrade' then
					upgrade.load()
				end
			end
			--Upgrade Menu
			if gamestate == 'upgrade' then 
				if v.id == 'pause' then
					for i=0,#button do
						table.remove(button, i)
					end
					for i=0,#button do
						table.remove(button, i)
					end
					delete_buttons = true
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#plus do
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
					end
					gamestate = 'paused'
				end

				if #button == 0 and #scale == 0 and gamestate == 'paused' and #plus == 0 then
					pause.load()
				end

			end
			--Options menu
				if gamestate == 'options' then
					if v.id == 'back' then
						for i=0,#scale do
							table.remove(scale, i)
						end
						for i=0,#scale do
							table.remove(scale, i)
						end
						for i=0,#scale do
							table.remove(scale, i)
						end
						for i=0,#button do
							table.remove(button, i)
						end
						for i=0,#button do
							table.remove(button, i)
						end
						delete_buttons = true
						for i=0,#button do
							table.remove(button, i)
						end
						for i=0,#button do
							table.remove(button, i)
						end
						for i=0,#button do
							table.remove(button, i)
						end
						for i=0,#button do
							table.remove(button, i)
						end
						for i=0,#button do
							table.remove(button, i)
						end
						for i=0,#button do
							table.remove(button, i)
						end
						gamestate = 'menu'
					end
					if #button == 0 and #scale == 0 then
							menu.load()
					end
				end

		end
		if gamestate == 'upgrade' and
		key == 'escape' then
			for i=0,#button do
						table.remove(button, i)
					end
					for i=0,#button do
						table.remove(button, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					for i=0,#scale do
						table.remove(scale, i)
					end
					delete_buttons = true
					for i=0,#plus do
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
						table.remove(plus, i)
					end
					gamestate = 'paused'
			switch_timer = 0
		end
	end
end

menu = {}

function menu.load()
	button.spawn(5,love.graphics.getHeight() / 2 - large:getHeight() / 2 - large:getHeight() * 2,'Start','start')
	button.spawn(5,love.graphics.getHeight() / 2 - large:getHeight() / 2,'Options','options')
	button.spawn(5,love.graphics.getHeight() / 2 - large:getHeight() / 2 + large:getHeight() * 2,'Quit','quit')
end
function menu.draw()
	love.graphics.setColor(255,0,0)
	love.graphics.setFont(large)
	if gamestate == 'menu' then
		love.graphics.print("Santa's Slaughter",love.graphics.getWidth() / 2 - large:getWidth("Santa's Slaughter") / 2,5)
	end
	if gamestate == 'options' then
		love.graphics.print("Options",love.graphics.getWidth() / 2 - large:getWidth("Options") / 2,5)
	end
	if gamestate == 'upgrade' then
		love.graphics.print("Upgrade",love.graphics.getWidth() / 2 - large:getWidth("upgrade") / 2,5)
	end
end

pause = {}

function pause.load()
	button.spawn(love.graphics.getWidth() / 2 - large:getWidth('Quit') / 2,love.graphics.getHeight() / 2 - large:getHeight() / 2 + large:getHeight() * 1.5,'Quit','menu')
	button.spawn(love.graphics.getWidth() / 2 - large:getWidth('Resume') / 2,love.graphics.getHeight() / 2 - large:getHeight() / 2 - large:getHeight() * 1.5,'Resume','play')
	button.spawn(love.graphics.getWidth() / 2 - large:getWidth('Upgrade!') / 2,love.graphics.getHeight() / 2 - large:getHeight() / 2,'Upgrade!','upgrade')
	scale.spawn(15,love.graphics.getHeight() / 2 - large:getHeight(),"song volume")
	scale.spawn(15,love.graphics.getHeight() / 2 + large:getHeight(),"sound volume")
end
function pause.draw()
	if gamestate == 'paused' then
		love.graphics.setFont(large)
		love.graphics.setColor(255,0,0)
		love.graphics.print('Paused',love.graphics.getWidth() / 2 - large:getWidth('paused') / 2,5)
	end
	--I'm cheating on you, Pause menu.
	if gamestate == 'upgrade' then
		love.graphics.setColor(255,0,0)
		love.graphics.setFont(large2)
		love.graphics.print('$'..player.money,love.graphics.getWidth() - large2:getWidth('$'..player.money),love.graphics.getHeight() - large2:getHeight())
	end
end


upgrade = {}
function upgrade.load()
	plus.spawn(10,150,1)--FireRate
	plus.spawn(10,250,2)--Mana Regeneration
	plus.spawn(10,450,3)--Health
	button.spawn(5,love.graphics.getHeight() - large:getHeight(),'Back','pause')
end

function plus_load()
	plus_data = {}
	plus_data[1] = {toprint = 'Fire Rate: ',id = 'rate',stagenum = 1,stage_lim = 5,button = "fire",notify = true}
	plus_data[1].prices = {250,500,750,1150,1350}
	plus_data[1].text = {"$250","$500","$750","$1150","$1350"}


	plus_data[2] = {toprint = 'Mana Regen: ',id = 'regen',stagenum = 1,stage_lim = 5,button = "mana",notify = true}
	plus_data[2].prices = {300,650,900,1275,1500}
	plus_data[2].text = {"$300","$650","$900","$1275","$1500"}

	plus_data[3] = {toprint = 'Max Health: ',id = 'health',stagenum = 1,stage_lim = 5,button = "health",notify = true}
	plus_data[3].prices = {100,350,600,700,1000}
	plus_data[3].text = {"$100","$350","$600","$700","$1000"}
end



function notify_upgrade()
	for i=1,#plus_data do
		if player.money > plus_data[i].prices[plus_data[i].stagenum] and plus_data[i].notify == true then
			note.spawn('New Upgrade!')
			plus_data[i].notify = false
		end
	end
end




plus = {}--The upgrade items
function plus.spawn(x,y,id)
	table.insert(plus, {x = x,y = y,id = id,text = plus_data[id].text,red = 255,green = 255,blue = 255,alpha = 255})
	
end
function plus.draw()
	for i,v in ipairs(plus) do

		love.graphics.setFont(large2)
		love.graphics.setColor(math.random(0,255),math.random(0,255),math.random(0,255))
		love.graphics.print(plus_data[v.id].toprint,v.x,v.y)
		love.graphics.setColor(0,255,0)
		love.graphics.print('Level '..plus_data[v.id].stagenum.."...",v.x + large2:getWidth(plus_data[v.id].toprint),v.y)
	
		love.graphics.setFont(large)
		love.graphics.setColor(v.red,v.green,v.blue,v.alpha)
		if plus_data[1].stagenum < plus_data[1].stage_lim or plus_data[1].stagenum == plus_data[1].stage_lim then
			love.graphics.print('Upgrade',v.x + large2:getWidth(plus_data[v.id].toprint) + large:getWidth('Level '..plus_data[v.id].stagenum.."..."),v.y)
		else
			love.graphics.print('Maxed Out!',v.x + large2:getWidth(plus_data[v.id].toprint) + large2:getWidth('Level '..plus_data[v.id].stagenum.."....."),v.y)
		end
		love.graphics.setFont(large2)
		love.graphics.setColor(255,0,0)
		love.graphics.print(plus_data[v.id].text[plus_data[v.id].stagenum],v.x + large2:getWidth(plus_data[v.id].toprint) + large2:getWidth('Level '..plus_data[v.id].stagenum.."........") + large:getWidth('Maxed Out'),v.y)
	end	
end
function plus.update(dt)
	for i,v in ipairs(plus) do
		--Telling you that you can upgrade!
		--
	mousex = love.mouse.getX()
	mousey = love.mouse.getY()
	if mousex > v.x + large2:getWidth(plus_data[v.id].toprint) + large2:getWidth('Level '..plus_data[v.id].stagenum..".....") and
	mousex < large2:getWidth(plus_data[v.id].toprint) + large2:getWidth('Level '..plus_data[v.id].stagenum..".....") + large:getWidth('Upgrade') and
	mousey > v.y and
	mousey < v.y + large2:getHeight() and plus_data[v.id].stagenum < plus_data[v.id].stage_lim then
		v.red = 200
		v.green = 200
		v.blue = 200
	else
		v.red = 255
		v.green = 255
		v.blue = 255
	end
	end
end
function plus.upgrade(x,y)
	for i,v in ipairs(plus) do
		if x > v.x + large2:getWidth(plus_data[v.id].toprint) + large2:getWidth('Level '..plus_data[v.id].stagenum..".....") and
		x < large2:getWidth(plus_data[v.id].toprint) + large2:getWidth('Level '..plus_data[v.id].stagenum..".....") + large:getWidth('Upgrade') and
		y > v.y and
		y < v.y + large2:getHeight() then
			if v.id == 1 and plus_data[1].stagenum < plus_data[1].stage_lim or plus_data[1].stagenum < plus_data[1].stage_lim then
				if player.money > plus_data[v.id].prices[plus_data[v.id].stagenum] or player.money == plus_data[v.id].prices[plus_data[v.id].stagenum] then
					if v.id == 1 then -- firerate
						player.firerate = player.firerate - 0.02	
					end
					if v.id == 2 then
						player.regen = player.regen + 7
					end
					if v.id == 3 then
						player.maxhealth = player.maxhealth + 1.5
					end
					player.money = player.money - plus_data[v.id].prices[plus_data[v.id].stagenum]
					plus_data[v.id].stagenum = plus_data[v.id].stagenum + 1
					notify('Upgraded!',love.graphics.getHeight() / 2,'green')
					TEsound.play(bell,'sound')
					plus_data[v.id].notify = true
				else
					notify('Not Enough Money!',love.graphics.getHeight() / 2,'red')
				end
			end
		end
	end
end











