effects = {}



local p_min = 50
local p_max = 100
local p_velocity_min = 100
local p_velocity_max = 350
--local p_lifetime = 100 -- no longer in use
local p_friction = 10
local p_limit = 1000000

local p_timer = 0
function place_effect(x,y,spread_deg,direction,image,life_time)
	local p_count = math.random(p_min,p_max)
	local effect_buffer = {image,life_time,{}}
	for i = 1, p_count do
		vel = math.random(p_velocity_min, p_velocity_max)
		local p_dir = math.rad(math.random(-spread_deg/2,spread_deg/2)) + direction
		local vx = math.cos(p_dir) * vel
		local vy = math.sin(p_dir) * vel 
		table.insert(effect_buffer[3], {x,y,vx,vy,0})
	end
	table.insert(effects, effect_buffer)

end

function update_effect(dt)
	for i,v in ipairs(effects) do

	if #effects > p_limit then
		
			table.remove(effects, i)
		
	end
	end

	for i,v in ipairs(effects) do
	--	if #v[3] < 1 then 
		--	table.remove(effects, i)
		--end

		for r,k in ipairs(v[3]) do
			if r > 1 then
				k[5] = k[5] + dt
				if math.abs(k[3]) > 1 then
					k[1] = k[1] + k[3] * dt
					k[2] = k[2] + k[4] * dt
					if math.abs(k[3]) > 0.1 then
						k[3] = k[3] - (k[3] * p_friction * dt)
					else
						k[3] = 0
					end
					if math.abs(k[4]) > 0 then
						k[4] = k[4] - (k[4] * p_friction * dt)
					else
						k[4] = 0
					end
				end
				if k[5] > v[2] then
					table.remove(v[3],r)
				end
			end
		end
	end
end

function draw_effect()
	for i,v in ipairs(effects) do
		for r,k in ipairs(v[3]) do
			if r > 1 then
				love.graphics.setColor(255,255,255)
				love.graphics.draw(v[1],k[1],k[2], 0, 0.8, 0.8)
			end
		end
	end

end