
player = {}



--Loading Images
playerU = {}
playerU[1] = love.graphics.newImage('pics/santaup.png')
playerU[2] = love.graphics.newImage('pics/santaup2.png')
playerU[3] = love.graphics.newImage('pics/santaup3.png')
playerU[4] = love.graphics.newImage('pics/santaup4.png')
playerU[5] = love.graphics.newImage('pics/santaup5.png')

playerD = {}
playerD[1] = love.graphics.newImage('pics/santadown.png')
playerD[2] = love.graphics.newImage('pics/santadown2.png')
playerD[3] = love.graphics.newImage('pics/santadown3.png')
playerD[4] = love.graphics.newImage('pics/santadown4.png')
playerD[5] = love.graphics.newImage('pics/santadown5.png')

playerR = {}
playerR[1] = love.graphics.newImage('pics/santaright.png')
playerR[2] = love.graphics.newImage('pics/santaright2.png')
playerR[3] = love.graphics.newImage('pics/santaright3.png')
playerR[4] = love.graphics.newImage('pics/santaright4.png')
playerR[5] = love.graphics.newImage('pics/santaright5.png')

playerL = {}
playerL[1] = love.graphics.newImage("pics/santaleft.png")
playerL[2] = love.graphics.newImage("pics/santaleft2.png")
playerL[3] = love.graphics.newImage("pics/santaleft3.png")
playerL[4] = love.graphics.newImage("pics/santaleft4.png")
playerL[5] = love.graphics.newImage("pics/santaleft5.png")

--Filtering Images
playerU[1]:setFilter("nearest",'nearest')
playerU[2]:setFilter("nearest",'nearest')
playerU[3]:setFilter("nearest",'nearest')
playerU[4]:setFilter("nearest",'nearest')
playerU[5]:setFilter("nearest",'nearest')

playerD[1]:setFilter("nearest",'nearest')
playerD[2]:setFilter("nearest",'nearest')
playerD[3]:setFilter("nearest",'nearest')
playerD[4]:setFilter("nearest",'nearest')
playerD[5]:setFilter("nearest",'nearest')

playerR[1]:setFilter('nearest','nearest')
playerR[2]:setFilter('nearest','nearest')
playerR[3]:setFilter('nearest','nearest')
playerR[4]:setFilter('nearest','nearest')
playerR[5]:setFilter('nearest','nearest')

playerL[1]:setFilter('nearest','nearest')
playerL[2]:setFilter('nearest','nearest')
playerL[3]:setFilter('nearest','nearest')
playerL[4]:setFilter('nearest','nearest')
playerL[5]:setFilter('nearest','nearest')


--Load the player data
function player.load()
	player.x = love.graphics.getWidth() * camera.scaleX / 2 - 8
	player.y = love.graphics.getHeight() * camera.scaleX / 2 - 8
	player.xvel = 0
	player.yvel = 0
	player.friction = 10
	player.speed = 1750

	player.width = 16
	player.height = 16

	player.dir = nil

	player.bullet = 1

	player.pic = playerU[1]

	player.mana = 100
	player.maxmana = 100

	player.regen = 7

	--Firerate
		player.firerate = 0.2
		player.rate = player.firerate
	--

	player.health = 10
	player.maxhealth = 10

	player.kills = 0

	player.attacked = false

	--Speed while being attacked
		player.aspeed = player.speed / 10
	--

	player.fire = false


	--Colors
	player.red = 255
	player.green = 255
	player.blue = 255

	player.color = false
	player.color_timer = 0
	player.money = 0
end
--Draw the player
function player.draw()
	if player.pic ~= nil then
		if gamestate ~= 'dead' then
		love.graphics.setColor(player.red,player.green,player.blue)
		love.graphics.draw(player.pic,player.x,player.y)
		end
	else
		if gamestate ~= 'dead' then
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle('fill',player.x,player.y,player.width,player.height)
		end
	end
end
function player.colorchange(dt)
	if player.color == true then
		player.color_timer = player.color_timer + dt
		if player.color_timer < 0.5 then
			player.red = 255
			player.green = 155
			player.blue = 155
		else
			player.green = 255
			player.blue = 255
		end
	end
end

local animtimer = 0
local step = false
local steptimer = 0
--Update the player data
function player.update(dt)
	--Mana Regeneration
	if player.mana < player.maxmana then
		player.mana = player.mana + player.regen * dt
	end
	if player.mana > player.maxmana then
		player.mana = player.maxmana
	end
	if player.mana < 0 then
		player.mana = 0
	end

	--Limiting health
	if player.health > player.maxhealth then
		player.health = player.maxhealth
	end


	player.x = player.x + player.xvel * dt
	player.y = player.y + player.yvel * dt

	--Friction
	player.xvel = player.xvel * (1 - math.min(dt*player.friction, 1))
	player.yvel = player.yvel * (1 - math.min(dt*player.friction, 1))


	--Step sound effect
	if step == true then
		TEsound.play(steps[math.random(1,#steps)],'step')
		step = false
	end


	--Limits
	if player.x < 0 then
		player.x = 0
		player.xvel = 0
	end
	if player.y < 0 then
		player.y = 0
		player.yvel = 0
	end
	if player.x + player.width > love.graphics.getWidth() * camera.scaleX then
		player.x = love.graphics.getWidth() * camera.scaleX - player.width
		player.xvel = 0
	end
	if player.y + player.height > love.graphics.getHeight() * camera.scaleY then
		player.y = love.graphics.getHeight() * camera.scaleY - player.height
	end

	if player.dir ~= nil then -- If any of the keys (W,A,S,D) are being held down.
		--Step sound effect

			steptimer = steptimer + dt
			if steptimer > 0.5 then
				step = true
				steptimer = 0
			end
	end

	--Animations
	if player.dir == "up" then
		animtimer = animtimer + dt
			

		if animtimer > 0.1 then
			player.pic = playerU[2]
		end
		if animtimer > 0.2 then
			player.pic = playerU[3]
		end
		if animtimer > 0.3 then
			player.pic = playerU[2]
		end
		if animtimer > 0.4 then
			player.pic = playerU[1]
		end
		if animtimer > 0.5 then
			player.pic = playerU[4]	
		end
		if animtimer > 0.6 then
			player.pic = playerU[5]
		end
		if animtimer > 0.7 then
			player.pic = playerU[4]

		end
		if animtimer > 0.8 then
			player.pic = playerU[1]
			animtimer = 0
		end

		if player.yvel > -player.speed and player.attacked == false then			
			player.yvel = player.yvel - player.speed * dt
		end
		if player.yvel > -player.aspeed and player.attacked == true then
			player.yvel = player.yvel - player.aspeed * dt
		end

	end	
	if player.dir == "down" then
		animtimer = animtimer + dt
		if animtimer > 0.1 then
			player.pic = playerD[2]
		end
		if animtimer > 0.2 then
			player.pic = playerD[3]
		end
		if animtimer > 0.3 then
			player.pic = playerD[2]
		end
		if animtimer > 0.4 then
			player.pic = playerD[1]
		end
		if animtimer > 0.5 then
			player.pic = playerD[4]
		end
		if animtimer > 0.6 then
			player.pic = playerD[5]
		end
		if animtimer > 0.7 then
			player.pic = playerD[4]
		end
		if animtimer > 0.8 then
			player.pic = playerD[1]
			animtimer = 0
		end

		if player.yvel < player.speed and player.attacked == false then
				player.yvel = player.yvel + player.speed * dt
		end
		if player.yvel < player.aspeed and player.attacked == true then
			player.yvel = player.yvel + player.aspeed * dt
		end
			
	end	
	if player.dir == "right" then
		animtimer = animtimer + dt
		if animtimer > 0.1 then
			player.pic = playerR[2]
		end
		if animtimer > 0.2 then
			player.pic = playerR[3]
		end
		if animtimer > 0.3 then
			player.pic = playerR[2]
		end
		if animtimer > 0.4 then
			player.pic = playerR[1]
		end
		if animtimer > 0.5 then
			player.pic = playerR[4]
		end
		if animtimer > 0.6 then
			player.pic = playerR[5]
		end
		if animtimer > 0.7 then
			player.pic = playerR[4]
		end
		if animtimer > 0.8 then
			player.pic = playerR[1]
			animtimer = 0
		end

		if player.xvel < player.speed and player.attacked == false then
				player.xvel = player.xvel + player.speed * dt
		end
		if player.xvel < player.aspeed and player.attacked == true then
			player.xvel = player.xvel + player.aspeed * dt			
		end
	end	
	if player.dir == "left" then
		animtimer = animtimer + dt
		if animtimer > 0.1 then
			player.pic = playerL[2]
		end
		if animtimer > 0.2 then
			player.pic = playerL[3]
		end
		if animtimer > 0.3 then
			player.pic = playerL[2]
		end
		if animtimer > 0.4 then
			player.pic = playerL[1]
		end
		if animtimer > 0.5 then
			player.pic = playerL[4]
		end
		if animtimer > 0.6 then
			player.pic = playerL[5]
		end
		if animtimer > 0.7 then
			player.pic = playerL[4]
		end
		if animtimer > 0.8 then
			player.pic = playerL[1]
			animtimer = 0
		end

		if player.xvel > -player.speed and player.attacked == false then
			player.xvel = player.xvel - player.speed * dt
		end
		if player.xvel > -player.aspeed and player.attacked == true then
			player.xvel = player.xvel - player.aspeed * dt
		end


	end
end

local timer = 0
--Shooting
function player.shoot(dt)

	--Shooting Right
	if love.keyboard.isDown('right') and not love.keyboard.isDown('left') and not love.keyboard.isDown('up') and not love.keyboard.isDown('down') then
		timer = timer + dt
		player.pic = playerR[1]
			if timer > player.rate then
				bullet.spawn(player.x + player.width, player.y + (player.height / 2),player.bullet,'right',nil)
				TEsound.play(snowball,'sound')
				timer = 0
			end
	end

	--Shooting Left
	if love.keyboard.isDown('left') and not love.keyboard.isDown('up') and not love.keyboard.isDown('right') and not love.keyboard.isDown('down') then
		timer = timer + dt
		player.pic = playerL[1]
			if timer > player.rate then
				bullet.spawn(player.x, player.y + (player.height / 2),player.bullet,'left',nil)
				TEsound.play(snowball,'sound')
				timer = 0
			end
	end

	--Shooting Down
	if love.keyboard.isDown('down') and not love.keyboard.isDown('up') and not love.keyboard.isDown('right') and not love.keyboard.isDown('left') then
		timer = timer + dt
		player.pic = playerD[1]
			if timer > player.rate then
				bullet.spawn(player.x + player.width / 2, player.y + player.height,player.bullet,'down',nil)
				TEsound.play(snowball,'sound')
				timer = 0
			end
	end

	--Shooting Up
	if love.keyboard.isDown('up') and not love.keyboard.isDown('left') and not love.keyboard.isDown('right') and not love.keyboard.isDown('down') then
		timer = timer + dt
		player.pic = playerU[1]
			if timer > player.rate then
				bullet.spawn(player.x + player.width / 2, player.y,player.bullet,'up',nil)
				TEsound.play(snowball,'sound')
				timer = 0
			end
	end
end



--Reseting the players animations so that when a key is released the animations stop and reset!
function player.animreset(key)
	if key == 'w' then
		player.pic = playerU[1]
		animtimer = 0
		if not love.keyboard.isDown('a') and not love.keyboard.isDown('d') and not love.keyboard.isDown('s') then
			player.dir = nil
		end
	end
	if key == 's' then
		player.pic = playerD[1]
		animtimer = 0
		if not love.keyboard.isDown('a') and not love.keyboard.isDown('d') and not love.keyboard.isDown('w') then
			player.dir = nil
		end
	end
	if key == "d" then
		player.pic = playerR[1]
		animtimer = 0
		if not love.keyboard.isDown('a') and not love.keyboard.isDown('s') and not love.keyboard.isDown('w') then
			player.dir = nil
		end
	end
	if key == 'a' then
		player.pic = playerL[1]
		animtimer = 0
		if not love.keyboard.isDown('s') and not love.keyboard.isDown('d') and not love.keyboard.isDown('w') then
			player.dir = nil
		end
	end
end
function player.move(key)
	if key == "d" then
		player.dir = "right"
	end
	if key == 'a' then
		player.dir = 'left' 
	end
	if key == 'w' then
		player.dir = 'up'
	end
	if key == 's' then
		player.dir = 'down'
	end
end

function bullet.draw()
	for i,v in ipairs(bullet) do
		if v.pic ~= nil then
			if player.fire == true then
				love.graphics.setColor(255,100,100)
			else
				love.graphics.setColor(255,255,255)
			end
			love.graphics.draw(v.pic,v.x,v.y)
		else
			if player.fire == true then
				love.graphics.setColor(255,100,100)
			else
				love.graphics.setColor(255,255,255)
			end
			love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)
		end
	end
end









